<template>
  <div>
    <Row>
      <!--查询-->
      <Col span="24" />
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="70"
        class="search-form"
      >
        <label class="label-sign" />
        <Form-item class="search-item" label="订单编号:">
          <Input v-model="formObj.num" placeholder="请输入订单编号" clearable @on-enter="_formSearch" />
        </Form-item>






        <Form-item class="search-btn">
          <Button type="primary" @click="_formSearch">
            搜索
          </Button>
        </Form-item>
      </Form>
      </Col>
      <!--按钮-->
      <Col span="24" />
      <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />
      </Col>
      <!--table-->
      <Col span="24" />
      <element-table
        ref="pageTable"
        :page-columns="pageColumns"
        :table-height="tableHeight"
        :get-page="getPage"
        :opt-col-width="80"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.key"
          show-overflow-tooltip
          sortable
          :prop="item.key"
          :label="item.title"
          :width="item.width"
          :min-width="200"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <div v-if="item.dateTime">
              {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}
            </div>
            <span v-else-if="item.type" class="blue-color">
              {{ scope.row[item.key] === undefined ? '': scope.row[item.key].display }}
            </span>
            <span v-else-if="item.status" class="blue-color">
              <span v-if="scope.row[item.key]===0" class="blue-color">待提交</span>
              <span v-else-if="scope.row[item.key]===5" class="red-color">驳回</span>
              <span v-else-if="scope.row[item.key]===3" class="green-color">待出库</span>
              <span v-else-if="scope.row[item.key]===1" class="blue-color">审批中</span>
              <span v-else-if="scope.row[item.key]===4" class="blue-color">完成</span>
              <span v-else class="red-color">审批未通过</span>
            </span>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
        <el-table-column
          slot="col"
          label="操作"
          align="center"
          :width="200"
          fixed="right"
        >
          <template slot-scope="scope">
            <icon-list
              :msg="scope.row['status']===0?iconMsgWait:iconMsg"
              :row-data="scope.row"
              @on-result-change="_iconClick"
            />
          </template>
        </el-table-column>
      </element-table>
      </Col>
    </Row>

    <!-- 申请详情 -->
    <LmsConsumeUseApplyDetail
      ref="chemicalDeliveryOrderDetailModal"
      @on-result-change="_page"
    />
  </div>
</template>
<script>
import { consumeDeliveryOrder } from '../../../api'
import LmsConsumeUseApplyDetail from './LmsConsumeUseApplyDetail'
export default {
  components: { LmsConsumeUseApplyDetail },
  data() {
    return {
      formObj: {
        num: ''
      },
      searchOpen: true,
      btn: [
        // { type: 'success', id: '', name: '添加' }
      ],
      pageColumns: [
        { title: '订单编号', key: 'num', width: 200 },
        { title: '状态', key: 'status', width: 120, status: true },
        { title: '申请人', key: 'applyer', width: 130 },
        { title: '申请内容', key: 'remark', width: 130 },
        { title: '创建时间', key: 'ctime', width: 170, date: true },
        { title: '最后修改时间', key: 'ltime', width: 190, date: true },
        { title: '审批意见', key: 'postil', width: 300 }
      ],
      getPage: {},
      iconMsg: [
        { type: 'pt-a-edit', id: '', name: '编辑' },
        { type: 'pt-a-trash', id: '', name: '删除' }
      ],
      iconMsgWait: [
        {
          type: 'pt-a-edit',
          id: '',
          name: '申请详情'
        },
        { type: 'pt-a-edit', id: '', name: '导出' },
        { type: 'pt-a-edit', id: '', name: '打印' },
        {
          type: 'pt-a-edit',
          id: '',
          name: '提交审批'
        },
        { type: 'pt-a-edit', id: '', name: '修改申请原因' },
        { type: 'pt-a-edit', id: '', name: '删除' }
      ],
      iconMsgDis: [
        { type: 'pt-a-edit', id: '', name: '编辑' },
        { type: 'pt-a-trash', id: '', name: '删除', disabled: true }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await consumeDeliveryOrder.page(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _searchParams(formId) {
      return this.$refs.pageTable._searchParams(formId)
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '申请详情':
          this._useApplyDetailModal(data)
          break
        case '删除':
          this._deleteById(data.id)
          break
      }
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该信息？',
        onOk: () => {
          this._delOk(id)
        }
      })
    },
    _delOk: async function(id) {
      const result = await consumeDeliveryOrder.deleteById(id)
      if (result) {
        this.$Message.success('删除成功')
        this._page()
      }
    },
    _editModal: async function(id) {
      const result = await consumeDeliveryOrder.getById(id)
      if (result) {
        this.$refs.editModal._open(result)
      }
    },
    _useApplyDetailModal(data) {
      this.$refs.chemicalDeliveryOrderDetailModal._open(data)
    }
  }
}
</script>
